//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowspOvO
// 
//  	Ver 3.14a
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "../DxCompileConfig.h"

// CN[h ---------------------------------------------------------------
#include "DxLogWin.h"

#ifndef DX_NON_LOG

#include "../DxStatic.h"
#include "../DxLib.h"
#include "../DxLog.h"
#include "../DxBaseFunc.h"
#include "../DxMemory.h"
#include "../DxGraphics.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "DxGraphicsWin.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// G[ot@C鏈̊ˑ
extern int ErrorLogInitialize_Native( void )
{
	HANDLE fp ;
	wchar_t String[ 512 ] ;
	int Len ;

	// Oo͗}tOĂ邩A[U[w̃EChE
	// gpĂꍇ͏o͂sȂ
	if( LogData.NotLogOutFlag == TRUE /* || WinData.UserWindowFlag == TRUE */ ) return 0 ;

	// t̃Oo͂w肳Ăꍇ̓t@C쐬
	if( LogData.UseLogDateName == TRUE )
	{
		DATEDATA Date ;
		wchar_t String[128] ;

		// t擾
		NS_GetDateTime( &Date ) ;

		// ̍쐬
		_WCSCPY( LogData.LogFileName, L"Log" ) ;
		_ITOAW( Date.Year, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Mon, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Day, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Hour, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Min, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L"_" ) ;
		_ITOAW( Date.Sec, String, 10 ) ;
		_WCSCAT( LogData.LogFileName, String ) ;
		_WCSCAT( LogData.LogFileName, L".txt" ) ;
	}
	else
	{
		// ȊȌꍇ͒ʏ̃t@C
		_WCSCPY( LogData.LogFileName, L"Log.txt" ) ;
	}

	// Oo̓tH_w肳ĂȂꍇ̓JgfBNgɂ
	if( LogData.LogOutDirectory[ 0 ] == L'\0' )
	{
		FGETDIR( String ) ; 
	}
	else
	{
		_WCSCPY( String, LogData.LogOutDirectory ) ;
	}

	Len = _WCSLEN( String ) ;
	if( String[ Len - 1 ] != L'\\' )
	{
		String[ Len ] = L'\\' ;
		Len ++ ;
	}
	_WCSCPY( String + Len, LogData.LogFileName ) ;

	// G[Ot@Cč쐬
	DeleteFileW( String ) ;
	fp = CreateFileW( String, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL ) ;

	BYTE BOM[ 2 ] = { 0xff, 0xfe } ;
	DWORD WriteSize ;
	WriteFile( fp, &BOM, 2, &WriteSize, NULL ) ;

	if( fp != NULL ) CloseHandle( fp ) ;

	// I
	return 0 ;
}

// G[o
extern int ErrorLogAdd_WCHAR_T( const wchar_t *ErrorStr )
{
	HANDLE fp ;
	DWORD WriteSize, StringLength ;
	wchar_t *Temp, DefaultTemp[512], *d, *AllocTemp = NULL ;
	const wchar_t *p1, *p2 ;

	if( WinAPIData.Win32Func.WinMMDLL == NULL )
	{
		LoadWinAPI() ;
		if( WinAPIData.Win32Func.WinMMDLL == NULL )
		{
			return -1 ;
		}
	}

	// ĂȂ珉
	if( LogData.InitializeFlag == FALSE )
	{
		if( ErrorLogInitialize() < 0 )
		{
			return -1 ;
		}
	}

	StringLength = ( DWORD )_WCSLEN( ErrorStr ) ;
	Temp = DefaultTemp ;

	// 񂪗]ɂe|̈Ŋmۂ
	if( StringLength > 512 - 1 )
	{
		Temp = AllocTemp = ( wchar_t * )NS_DxAlloc( StringLength * 2 * sizeof( wchar_t ) ) ;
	}

	// \n  \r\n ɕϊȂRs[
	{
		Temp[0] = L'\0' ;
		p1 = ErrorStr ;
		d = Temp ;

		p2 = _WCSCHR( p1, L'\n' ) ;
		while( p2 != NULL && ( ErrorStr == p2 || p2[-1] != L'\r' ) )
		{
			_MEMCPY( d, p1, ( p2 - p1 ) * sizeof( wchar_t ) ) ;
			d += p2 - p1 ;
			d[0] = L'\r' ;
			d[1] = L'\n' ;
			d[2] = L'\0' ;
			d += 2 ;
			p1 = p2 + 1 ;

			p2 = _WCSCHR( p1, L'\n' ) ;
		}
		_WCSCPY( d, p1 ) ;
		ErrorStr = Temp ;
	}

	// cwCu쐬EChEłꍇ̂݃t@Cɏo͂
	if( /*WinData.MainWindow != NULL && WinData.UserWindowFlag == FALSE */ true )
	{
		// Oo͗}tOĂꍇ͏o͂sȂ
		if( LogData.NotLogOutFlag == FALSE )
		{
			wchar_t String[ FILEPATH_MAX ] ;
			int Len ;

			// Oo̓tH_w肳ĂȂꍇ̓JgfBNgɂ
			if( LogData.LogOutDirectory[ 0 ] == L'\0' )
			{
				FGETDIR( String ) ; 
			}
			else
			{
				_WCSCPY( String, LogData.LogOutDirectory ) ;
			}

			// G[Ot@CJ
			Len = _WCSLEN( String ) ;
			if( String[ Len - 1 ] != L'\\' )
			{
				String[ Len ] = L'\\' ;
				Len ++ ;
			}
			_WCSCPY( String + Len, LogData.LogFileName ) ;
			fp = CreateFileW( String, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL ) ;
			if( fp != NULL )
			{
				SetFilePointer( fp, 0, NULL, FILE_END ) ;

				// K蕪^uro
				if( LogData.ErTabStop == FALSE )
				{
					int i ;	

					// ^CX^vo
					if( LogData.NonUseTimeStampFlag == 0 )
					{
						_SWPRINTF( String, L"%d:", WinAPIData.Win32Func.timeGetTimeFunc() - LogData.LogStartTime ) ;
						WriteFile( fp, String, _WCSLEN( String ) * sizeof( wchar_t ), &WriteSize, NULL ) ;
						OutputDebugStringW( String ) ;
					}

					if( LogData.ErTabNum != 0 )
					{
						for( i = 0 ; i < LogData.ErTabNum ; i ++ )
						{
							String[i] = L'\t' ;
						}
						String[i] = L'\0' ;
						WriteFile( fp, String, LogData.ErTabNum * sizeof( wchar_t ), &WriteSize, NULL ) ;
						OutputDebugStringW( String ) ;
					}
				}

				// G[Ot@Cɏo
				WriteFile( fp, ErrorStr, _WCSLEN( ErrorStr ) * sizeof( wchar_t ), &WriteSize, NULL ) ;

				// G[OAEgvbgɏo
				OutputDebugStringW( ErrorStr ) ;

				// Ō̕sӊOꍇ̓^uXgbvtO𗧂Ă
				LogData.ErTabStop = ErrorStr[ _WCSLEN( ErrorStr ) - 1 ] != L'\n' ;

				CloseHandle( fp ) ;
			}
//			FSETDIR( MotoPath ) ;
		}
	}
	else
	{
		// G[OAEgvbgɏo
		OutputDebugStringW( ErrorStr ) ;
	}

	// e|̈mۂĂJ
	if( AllocTemp != NULL )
	{
		NS_DxFree( AllocTemp ) ;
	}
	
	// I
	return -1 ;
}


// O@\̏sǂ擾
extern int IsInitializeLog( void )
{
	if( WinData.MainWindow == NULL )
	{
		return FALSE ;
	}

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware )
	{
		switch( GRAWIN.Setting.UseGraphicsAPI )
		{
#ifndef DX_NON_DIRECT3D11
		case GRAPHICS_API_DIRECT3D11_WIN32 :
			return D3D11Device_IsValid() ? TRUE : FALSE ;
#endif // DX_NON_DIRECT3D11

#ifndef DX_NON_DIRECT3D9
		case GRAPHICS_API_DIRECT3D9_WIN32 :
			return NS_GetUseDDrawObj() == NULL ? FALSE : TRUE ;
#endif // DX_NON_DIRECT3D9

		default :
			return FALSE ;
		}
	}
	else
	{
		// cwCuIԂɓĂ珉Ȃ
		return NS_GetUseDDrawObj() == NULL || WinData.MainWindow == NULL ? FALSE : TRUE ;
	}

	return TRUE ;
}


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_LOG

